argc=$#
script=$0
if [ $argc -ne 3 ]; then
  echo "Usage:"
  echo "  $script [interpreter version] [developer id] [input name]"
  echo
  echo "Example:"
  echo "  $script inspect i1 bufovfint1"
  echo "  $script control c1 bufovfint1"
  echo "  $script foc c1 bufovfint1"
  exit 1
fi
version=$1
prog=submissions/$2/thumbnail.stu
testcase=inputs/$3.in

cp $testcase input3.txt
if [ $? -ne 0 ]; then
  echo "Error: Input file $testcase not found"
  exit 1
fi

echo "Program $prog ($version)"

if [[ $version == "inspect" ]]; then
  if [[ $2 == i* ]]; then
    echo "====== $testcase ======"
    interpreters/inspect/a.out $prog 0
  else
    echo "Error: Developer $2 must come from inspect group"
    exit 1
  fi
elif [[ $version == "control" ]]; then
  if [[ $2 == c* ]]; then
    echo "====== $testcase ======"
    interpreters/control/a.out $prog 0
  else
    echo "Error: Developer $2 must come from control group"
    exit 1
  fi
elif [[ $version == "foc" ]]; then
  if [[ $2 == c* ]]; then
    echo "====== $testcase ======"
    interpreters/foc/a.out $prog 0
  else
    echo "Error: Developer $2 must come from control group"
    exit 1
  fi
fi

rm input3.txt
