###################
##### Defects #####
###################
inspect_fatal_defects <- c(0,0,0,0,0)
control_fatal_defects <- c(4,5,2,4,3)
inspect_other_defects <- c(1,0,1,2,2)
control_other_defects <- c(2,4,0,4,5)
inspect_all_defects <- inspect_fatal_defects + inspect_other_defects
control_all_defects <- control_fatal_defects + control_other_defects

# All defects
wilcox.test(inspect_all_defects,control_all_defects,paired=TRUE,alternative="l")

# Fatal defects
wilcox.test(inspect_fatal_defects,control_fatal_defects,paired=TRUE,alternative="l")

# Other defects
wilcox.test(inspect_other_defects,control_other_defects,paired=TRUE,alternative="l")

##################
##### Inputs #####
##################
inspect_crash_rare <- c(0,0,0,0,0)
control_crash_rare <- c(1,2,1,2,1)
foc_crash_rare <- c(0,0,0,0,0)
inspect_wrong_rare <- c(0,0,0,0,0)
control_wrong_rare <- c(0,0,0,0,0)
foc_wrong_rare <- c(1,2,1,0,1)
inspect_crash_illegal <- c(0,0,0,0,0)
control_crash_illegal <- c(10,12,2,7,6)
foc_crash_illegal <- c(0,4,0,0,0)
inspect_wrong_illegal <- c(0,0,2,1,4)
control_wrong_illegal <- c(7,7,0,3,11)
foc_wrong_illegal <- c(16,14,1,8,17)
inspect_crash_total <- inspect_crash_rare + inspect_crash_illegal
inspect_wrong_total <- inspect_wrong_rare + inspect_wrong_illegal
control_crash_total <- control_crash_rare + control_crash_illegal
control_wrong_total <- control_wrong_rare + control_wrong_illegal
foc_crash_total <- foc_crash_rare + foc_crash_illegal
foc_wrong_total <- foc_wrong_rare + foc_wrong_illegal

# Crashes or infinite loops, original
wilcox.test(inspect_crash_rare,control_crash_rare,paired=TRUE,alternative="l")
wilcox.test(inspect_crash_illegal,control_crash_illegal,paired=TRUE,alternative="l")
wilcox.test(inspect_crash_total,control_crash_total,paired=TRUE,alternative="l")

# Crashes or infinite loops, FOC
wilcox.test(inspect_crash_rare,foc_crash_rare,paired=TRUE,alternative="l")
wilcox.test(inspect_crash_illegal,foc_crash_illegal,paired=TRUE,alternative="l")
wilcox.test(inspect_crash_total,foc_crash_total,paired=TRUE,alternative="l")

# Wrong outputs, original
wilcox.test(inspect_wrong_rare,control_wrong_rare,paired=TRUE,alternative="l")
wilcox.test(inspect_wrong_illegal,control_wrong_illegal,paired=TRUE,alternative="l")
wilcox.test(inspect_wrong_total,control_wrong_total,paired=TRUE,alternative="l")

# Wrong outputs, FOC
wilcox.test(inspect_wrong_rare,foc_wrong_rare,paired=TRUE,alternative="l")
wilcox.test(inspect_wrong_illegal,foc_wrong_illegal,paired=TRUE,alternative="l")
wilcox.test(inspect_wrong_total,foc_wrong_total,paired=TRUE,alternative="l")

######################
##### Complexity #####
######################
inspect_cyclo <- c(15,12,13,15,13)
inspect_cond <- c(6,7,2,5,6)
inspect_loc <- c(109,64,92,92,56)
inspect_stmt <- c(61,49,63,59,41)
inspect_uncond <- c(58,45,62,56,37)

control_cyclo <- c(20,24,43,34,22)
control_cond <- c(13,11,25,21,12)
control_loc <- c(74,118,178,136,100)
control_stmt <- c(50,85,93,99,63)
control_uncond <- c(43,76,84,80,57)

# Cyclomatic complexity
wilcox.test(inspect_cyclo, control_cyclo, paired=TRUE, alternative="l")

# Conditional clauses
wilcox.test(inspect_cond, control_cond, paired=TRUE, alternative="l")

# Lines of code
wilcox.test(inspect_loc, control_loc, paired=TRUE, alternative="l")

# All statements
wilcox.test(inspect_stmt, control_stmt, paired=TRUE, alternative="l")

# Unconditional statements
wilcox.test(inspect_uncond, control_uncond, paired=TRUE, alternative="l")


