measure[0]="Cyclomatic complexity"
measure[1]="Conditional clauses"
measure[2]="Statements overall"
measure[3]="Statements manipulating data"

column[0]="cyclomatic"
column[1]="cond-clauses"
column[2]="all-stmt"
column[3]="uncond-stmt"
column[4]="loc"

version[0]="idir"
version[1]="edir"
version[2]="eder"
version[3]="plain"

# Traverse directories, each with an application
dirlist=$(find ./programs -mindepth 1 -maxdepth 1 -type d)
for dir in $dirlist
do
  prefix="./"
  app=${dir#$prefix}

  # Print table header
  printf "app | version"
  for i in {0..4}
  do
    printf " | ${column[i]}"
  done
  printf "\n"
    
  # Count complexity for each version
  for i in {0..3}
  do
    printf "$(basename $app) | ${version[i]}"
    file="$app/${version[i]}.rifl"
    count=$(../complexity/a.out $file)
    # Cyclomatic complexity, conditional clauses, statements overall, statements manipulating data
    for j in {0..3}
    do
      printf " | "
      echo $count | grep -Eo "${measure[j]}: [0-9]+" | grep -o "[0-9]*" | tr -d '\n'
    done
    printf " | "
    # Lines of code
    loc=$(wc $file | grep -Eo '^ *[0-9]*')
    printf "$loc\n"
  done
  printf "\n"
done
